unit ufrmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, uEnlace, ExtCtrls;

type
  TfrmMain = class(TForm)
    lbDisplay: TLabel;
    tbPeso: TTrackBar;
    btnIniciar: TButton;
    cmbPuerto: TComboBox;
    Label1: TLabel;
    rdgSeparador: TRadioGroup;
    procedure tbPesoChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnIniciarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure rdgSeparadorClick(Sender: TObject);
  private
    { Private declarations }
    Enlace: TThreadEnlace;
    procedure OnCommand(Sender: TObject; Command: String;
      var Response: String);
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

uses Registry;

procedure GetPortList(List: TStrings);
var
  i: integer;
begin
  List.Clear;
  with TRegistry.Create do
  try
    RootKey:= HKEY_LOCAL_MACHINE;
    Access:= KEY_READ;
    if OpenKey('HARDWARE\DEVICEMAP\SERIALCOMM',FALSE) then
    begin
      GetValueNames(List);
      for i:= List.Count - 1 downto 0 do
        List[i]:= ReadString(List[i]);
      CloseKey;
    end;
  finally
    Free;
  end;
end;

procedure TfrmMain.btnIniciarClick(Sender: TObject);
begin
  if Enlace <> nil then
  begin
    FreeAndNil(Enlace);
    btnIniciar.Caption:= 'Iniciar';
  end else
  if cmbPuerto.ItemIndex >= 0 then
  begin
    FreeAndNil(Enlace);
    with cmbPuerto do
      Enlace:= TThreadEnlace.Create(Items[ItemIndex],TRUE);
    Enlace.OnCommand:= Self.OnCommand;
    btnIniciar.Caption:= 'Parar';
  end;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FreeAndNil(Enlace);
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  Enlace:= nil;
  DecimalSeparator:= '.';
  tbPesoChange(nil);
  // Obtenemos la lista de puestos
  GetPortList(cmbPuerto.Items);
  // Y si no encontramos ninguno creamos una lista generica
  if cmbPuerto.Items.Count = 0 then
    for i:= 1 to 99 do
      cmbPuerto.Items.Add(Format('COM%d',[i]));
  if cmbPuerto.Items.Count > 0 then
    cmbPuerto.ItemIndex:= 0;
end;

procedure TfrmMain.OnCommand(Sender: TObject; Command: String;
  var Response: String);
begin
  if Pos('$',Command) > 0  then
    Response:= FormatFloat('000.000',tbPeso.Position / 1000) + #13;
end;

procedure TfrmMain.rdgSeparadorClick(Sender: TObject);
begin
  case rdgSeparador.ItemIndex of
    0: DecimalSeparator:= '.';
    1: DecimalSeparator:= ',';
  end;
  tbPesoChange(nil);
end;

procedure TfrmMain.tbPesoChange(Sender: TObject);
begin
  lbDisplay.Caption:= #32+FormatFloat('00.000',tbPeso.Position / 1000)+' KG';
end;

end.
